import { Color, ItemsSource, Property, View, ViewBase } from '@nativescript/core';
import { IndicatorHolder } from '.';
export declare enum Indicator {
    Disabled = "disable",
    None = "none",
    Worm = "worm",
    Fill = "fill",
    Swap = "swap",
    Thin_worm = "thin_worm",
    Flat = "flat"
}
export declare const colorProperty: Property<PagerIndicatorBase, string | Color>;
export declare const selectedColorProperty: Property<PagerIndicatorBase, string | Color>;
export declare const itemsProperty: Property<PagerIndicatorBase, any>;
export declare const typeProperty: Property<PagerIndicatorBase, Indicator>;
export declare const pagerViewIdProperty: Property<PagerIndicatorBase, string>;
export declare abstract class PagerIndicatorBase extends View {
    items: any[] | ItemsSource;
    color: Color;
    selectedColor: Color | string;
    type: Indicator;
    pagerView: View & IndicatorHolder;
    pagerViewId: string;
    getPage(): any;
    getTopmost<View>(arg: ViewBase): any;
    disposeNativeView(): void;
    onLoaded(): void;
    setPagerView(view: View): void;
    abstract setSelection(index: number, animated?: boolean): any;
    abstract setProgress(position: number, progress: number): any;
    abstract setCount(count: number): any;
    abstract getCount(): number;
    abstract getSelection(): number;
    abstract setInteractiveAnimation(animated?: boolean): any;
    abstract withoutAnimation(callback: Function): any;
}
